/*
Murasaki - multiple genome global alignment program
Copyright (C) 2006-2007 Keio University
(Kris Popendorf) <comp@bio.keio.ac.jp> (2006)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "sequence.h"

class MSetHash : public Hash {
 public:
  //my own lovely bunch of coconuts
  typedef multiset<HashVal>*  MHash; //multihash
  typedef multiset<HashVal>::iterator HashIte;

  void clear();
  void add(const HashKey key,const HashVal &val);
  void lookup(HashKey key,const HashVal &a,LocList &locList);
  void lookup(HashKey key,LocList &locList); //this is just for debugging...
  bool next(HashVal *v);
  bool emptyAt(const HashKey key);
  word sizeAt(const HashKey key);

  MSetHash(BitSequence *pat);

  static const word linear_cost(word c) {
    return sizeof(Location)*c;
  }
  static const word bucket_prep_cost(word c) {
    return sizeof(multiset<HashVal>)*c;
  }

 protected:
  MHash *fasta;
  pair<HashIte,HashIte> activeRange;
};
